package web.multitask.trismegistoservices.rest.BBVA;

import org.json.JSONObject;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import web.multitask.trismegistoservices.services.BBVA.bbvaService;
import web.multitask.trismegistoservices.singleton.bbvaSingleton;

@RestController
@CrossOrigin(origins = "*")
@RequestMapping("bbva")
public class bbvaRest {

    private final bbvaService service;
    private final bbvaSingleton singleton;

    public bbvaRest(bbvaService service, bbvaSingleton singleton) {
        this.service = service;
        this.singleton = singleton;
    }

    @PostMapping("/private/prepareRequest")
    public ResponseEntity<?> getHeader(@RequestBody String json) {
        JSONObject response = service.getToken(json);
        String token = response.optString("access_token");
        if(token.isEmpty()){
            return ResponseEntity.internalServerError().body(response.put("status",false).put("token","").toMap());
        }else{
            singleton.setToken(token);
            String digest = service.bodyIntoBase64AfterSHA512(json);
            singleton.setDigest(digest);
            String txt = service.txtToSign(json ,digest);
            String signature = service.createSignature(txt);
            singleton.setSignature(signature);
            System.out.println("token = "+singleton.getToken());
            System.out.println("digest = "+singleton.getDigest());
            System.out.println("signature = "+singleton.getSignature());
            return ResponseEntity.ok(service.generateQR(singleton.getToken(),singleton.getDigest(),singleton.getSignature(),json).toMap());
        }
    }

}
